<template>
  <div class="row">
    <div class="columns four">
      <label for="bDay">Дата рождения</label>

      <input type="tel"
             name="дата рождения"
             id="bDay"
             v-validate="birthdayValidator"
             :class="[getValidateClass('дата рождения'), {'data-processing': SUGGESTIONS_LOADER.b_day}]"
             v-model="$user.bDay"
             v-mask="'##.##.####'"
             placeholder="ДД.ММ.ГГГГ"
             :keepCharPositions="true"
             autocomplete="off"
             data-code="bDayInvalidDateFormat"
      >
      <validate-message v-show="vErrors.has('дата рождения')">
        {{ vErrors.first('дата рождения') }}
      </validate-message>
      <validate-message v-show="userFioAndBirthDayNotUnique">
        Указанные данные уже зарегистрированы. <router-link to="/login">Перейдите в личный кабинет</router-link>
      </validate-message>

    </div>

    <div class="columns four">
      <label for="bPlace">Место рождения</label>
      <input type="text"
             name="bPlace"
             id="bPlace"
             v-model="$user.bPlace"
             v-validate="'required|exceptLatinAndServiceChar|min:3'"
             :class="getValidateClass('bPlace')"
             autocomplete="off"
             data-code="bPlaceTooLong, bPlaceTooShort, bPlaceInvalidFormat"
      />
      <validate-message v-show="vErrors.has('bPlace')">
        {{ vErrors.first('bPlace') }}
      </validate-message>
    </div>

    <div class="columns four checkbox">
      <div class="label">Пол</div>
      <input type="radio"
             name="gender"
             value="male"
             id="male"
             v-model="$user.gender"
             v-validate="'required'"
             data-code="genderNotInAvailableRange"
      />

      <label for="male"><span></span>Мужской</label>
      <input type="radio"
             name="gender"
             value="female"
             id="female"
             v-model="$user.gender"
             v-validate="'required'"
             :class="getValidateClass('female')"
             data-code="genderNotInAvailableRange"
      />

      <label for="female"><span></span>Женский</label>
      <div class="checkbox-gender">
        <validate-message v-show="vErrors.has('gender')">
          {{ vErrors.first('gender') }}
        </validate-message>
      </div>

    </div>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import debounce from 'lodash/debounce'
  import {mapGetters} from 'vuex'
  let request;

  export default {
    name: 'birthday',
    data () {
      return {
        birthdayValidator: `required|date_format_check|date_between_bd`,
        userFioAndBirthDayNotUnique: false
      }
    },
    components: {
      ValidateMessage
    },
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    computed: {
      ...mapGetters(['SUGGESTIONS_LOADER'])
    },
    watch: {
      '$user.bDay': debounce(function () {
        this.checkPersonalDataForUnique()
      }, 200)
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD);
      this.$validator.localize(MIN_LENGHT);
      this.$validator.localize(MAX_LENGHT);
      this.checkPersonalDataForUnique()
    },
    updated () {
      this.$user.validate.step2.birthDate = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    },
    methods: {
      async checkPersonalDataForUnique () {
        if (this.$route.name === 'registration') {
          if (this.$user.bDay && this.$user.bDay.length === 10) {
            let data = {
                bDay: this.$user.bDay,
                firstName: this.$user.firstName,
                lastName: this.$user.lastName,
                middleName: this.$user.middleName
            };

            // this.$store.commit('SUGGESTIONS_SET_LOADER', {b_day: true}); // включаем лоадер, пока грузяться данные

            if(request) {
              request.abort(); // отменяем предыдующие запросы, если запросы не успели подгрузиться
            }

            request = await this.$store.dispatch('SUGGESTIONS_GET_B_DAY', data);

            request.onreadystatechange = function () {
              // результат на то, что введены верно инициалы и дата рождения
              if(request.readyState === XMLHttpRequest.DONE) {
                switch (request.status) {
                  case 200:
                    this.userFioAndBirthDayNotUnique = false;
                    this.$emit('error', {
                      key: 'userNotUnique',
                      value: false
                    })
                    break;
                  case 400:
                    if (this.$getErrorCode(request.response) === 'userFioAndBirthDayNotUnique') {
                      this.userFioAndBirthDayNotUnique = true;
                      this.$emit('error', {
                        key: 'userNotUnique',
                        value: true
                      })
                    }
                    break;
                }
                // this.$store.commit('SUGGESTIONS_SET_LOADER', {b_day: false});
                request = null;
              }
            }.bind(this);
          }
        }
      }
    }
  }
</script>

<style scoped>
.checkbox-gender {
  text-align: center;
  margin-top: 32px;
}
</style>

